/*------------------------------------------------------------------------------
 bin/djv_ls/app.h

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_LS_APP
#define DJV_LS_APP

#include <djv_base/app.h>
#include <djv_base/file.h>

namespace djv_ls {
using namespace djv_base;

//------------------------------------------------------------------------------
// Application

class App : public djv_base::app::App
{
public:

  App(int, char **);
  ~App();

private:

  void file(const File &, bool path = false);
  bool dir(const File &, bool label);
  
  void cmdln(Str &) throw (Error);
  Str cmdln_help() const;

  List<Str> _input;
  file::SEQ_COMPRESS _seq;
  bool _recurse;
  bool _hidden;
  List<Str> _filter;
  int _columns;
  file::SORT _sort;
  bool _sort_reverse;
  bool _sort_dir;
};

}

#endif

