/*------------------------------------------------------------------------------
 bin/djv_view/image_info.h

 Image Information
 -----------------
 
 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_VIEW_IMAGE_INFO_H
#define DJV_VIEW_IMAGE_INFO_H

#include <djv_ui/dialog.h>
#include <djv_image/image.h>
#include <djv_image/tag.h>

namespace djv_view {
namespace image_info {
using namespace djv_base;

//------------------------------------------------------------------------------
// Info

struct Info
{
  Info(const djv_image::Image * in = 0) :
    info(in ? in->info() : djv_image::Info()),
    tag(in ? in->tag : djv_image::Tag())
  {}

  djv_image::Info info;
  djv_image::Tag tag;
};

//------------------------------------------------------------------------------
// Dialog

class Dialog : public djv_ui::dialog::Base
{
public:
  
  Dialog();
  ~Dialog();
  void del() { Base::del(); }
  
  // Value.
  
  void set(const void *, const Info &);
  void pick(const void *, const Info &);
  void update(const void *, const Info &);
  void del(const void *);
  
  // Widget.
  
  void show();
  
  // Layout.
  
  void update() { Base::update(); }

private:
  
  DJV_CALLBACK(Dialog, close_callback, bool);
  
  void widget_update();

  const void * _obj;
  Info _info;
  
  struct _Dialog;
  std::auto_ptr<_Dialog> _p;
};

//------------------------------------------------------------------------------
// Labels

extern const Str
  dialog_title,
  dialog_name,
  dialog_size,
  dialog_pixel,
  dialog_tag;

//------------------------------------------------------------------------------
// Global

Dialog * dialog();

}
}

#endif

