/*------------------------------------------------------------------------------
 bin/djv_view/playback_prefs.cxx

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include "app.h"
#include "playback.h"
#include <djv_ui/prefs.h>

namespace djv_view {
namespace playback {

Prefs::Prefs() :
  every_frame_sig(this),
  _start(true),
  _every_frame(true)
{
  djv_ui::prefs::Prefs prefs(djv_ui::prefs::prefs(), "playback");
  djv_ui::prefs::get(&prefs, "start", &_start);
  djv_ui::prefs::get(&prefs, "every_frame", &_every_frame);
}

Prefs::~Prefs()
{
  djv_ui::prefs::Prefs prefs(djv_ui::prefs::prefs(), "playback");
  djv_ui::prefs::set(&prefs, "start", _start);
  djv_ui::prefs::set(&prefs, "every_frame", _every_frame);
}

void Prefs::start(bool in)
{
  _start = in;
}

bool Prefs::start() const { return _start; }

void Prefs::every_frame(bool in)
{
  if (in == _every_frame) return;
  
  _every_frame = in;
  
  every_frame_sig.emit(_every_frame);
}

bool Prefs::every_frame() const { return _every_frame; }

}
}

