/*------------------------------------------------------------------------------
 bin/djv_view/playback_prefs_widget.cxx

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include "playback.h"
#include <djv_ui/button.h>
#include <djv_ui/group.h>
#include <djv_ui/label.h>
#include <djv_ui/layout_row.h>
#include <djv_ui/menu.h>
#include <djv_ui/style.h>
#include <djv_ui/text.h>

namespace djv_view {
namespace playback {

Prefs_Widget::Prefs_Widget()
{
  using namespace djv_ui;
  
  // Widgets.

  group::Box * group =
    new group::Box(prefs_group);
  button::Check * start_widget =
    new button::Check(prefs_start);
  button::Check * every_frame_widget =
    new button::Check(prefs_every_frame);

  // Layout.
  
  Layout_V * layout, * layout_group;
  
  layout = new Layout_V(this);
  
  layout->add(group);
  layout_group = new Layout_V(group);
  layout_group->spacing(style::global()->spacing_large());
  layout_group->add(start_widget);
  layout_group->add(every_frame_widget);

  layout->add_stretch();

  // Initialize.
  
  start_widget->set(prefs()->start());
  every_frame_widget->set(prefs()->every_frame());

  // Callbacks.

  start_widget->sig.set(this, start_callback);
  every_frame_widget->sig.set(this, every_frame_callback);
}

void Prefs_Widget::start_callback(bool in)
  { prefs()->start(in); }

void Prefs_Widget::every_frame_callback(bool in)
  { prefs()->every_frame(in); }

}
}
