/*------------------------------------------------------------------------------
 include/djv_base/dir.h
 
 File System Directory
 ---------------------

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_DIR_H
#define DJV_DIR_H

#include <djv_base/file.h>

namespace djv_base {
namespace dir {

//------------------------------------------------------------------------------
// Directory

class Dir
{
public:

  Dir();
  Dir(const Str &);

  // Value.
  
  void set(const Str &);
  const Str & get() const;
  
  // Item list.
  
  List<File> list() const;

  // Functions.
  
  void cd(const Str &);
  void up();

  bool valid() const;

private:

  void update();
  
  Str _path;
  bool _valid;
};

//------------------------------------------------------------------------------
// Functions

Str desktop();
#if ! defined(WIN32)
Str home();
#endif

#if defined(WIN32)
List<Str> drive_list();
#else
Str root();
#endif

}

//------------------------------------------------------------------------------
// Declarations

using dir::Dir;

}

#endif

