/*------------------------------------------------------------------------------
 include/djv_ui/file.h
 
 File Widget
 -----------

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_FILE_H
#define DJV_UI_FILE_H

#include <djv_base/file.h>
#include <djv_ui/widget.h>

namespace djv_ui {
namespace file {

//------------------------------------------------------------------------------
// Widget

class Widget : public widget::Widget
{
public:

  Widget();
  ~Widget();

  // Value.
  
  void set(const File &);
  const File & get() const;
  Signal<const File &> sig;
  
private:

  DJV_CALLBACK(Widget, widget_callback, const Str &);
  DJV_CALLBACK(Widget, dialog_callback, bool);
  DJV_CALLBACK(Widget, dialog_callback, const File &);
  
  void widget_update();
  
  File _value;
  
  struct _Widget;
  std::auto_ptr<_Widget> _p;
};

//------------------------------------------------------------------------------
// Functions

void recent(const Str &, List<Str> *, int max = 10);

//------------------------------------------------------------------------------
// Labels

extern const Str
  label_browse;

}
}

#endif

