/*------------------------------------------------------------------------------
 include/djv_ui/pixel.h
 
 Pixel Widget
 ------------
 
 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_PIXEL_H
#define DJV_UI_PIXEL_H

#include <djv_image/pixel.h>
#include <djv_ui/widget.h>

namespace djv_ui {
namespace pixel {

//------------------------------------------------------------------------------
// Widget

class Widget : public widget::Widget
{
public:

  Widget();
  virtual ~Widget();
  virtual void del();

  // Value.
  
  void set(djv_image::PIXEL);
  djv_image::PIXEL get() const;
  Signal<djv_image::PIXEL> sig;
  
  // Widget.
  
  virtual void draw();
  
  // Layout.
  
  virtual void dirty();
  virtual void geom(const Box2i &);
  virtual const Box2i & geom() const;
  
  // Debugging.
  
  virtual Str dbg_name() const { return "djv::ui::pixel::Widget"; }
  
private:

  DJV_CALLBACK(Widget, widget_callback, int);
  
  void widget_update();

  djv_image::PIXEL _value;
  
  struct _Widget;
  std::auto_ptr<_Widget> _p;
};

}
}

#endif
