/*------------------------------------------------------------------------------
 include/djv_ui/shortcut.h

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_SHORTCUT_H
#define DJV_UI_SHORTCUT_H

#include <djv_ui/widget.h>

namespace djv_ui {
namespace shortcut {

//------------------------------------------------------------------------------
// Shortcut

struct Shortcut
{
  Shortcut(const Str & name = Str(), int value = 0) :
    name(name),
    value(value)
  {}
  
  Str name;
  int value;
};

//------------------------------------------------------------------------------
// Widget

class _Callback_Data;

class Widget : public widget::Widget
{
public:

  Widget();
  ~Widget();
  
  // Value.
  
  void set(const List<Shortcut> & in);
  const List<Shortcut> & get() const;
  Signal<const List<Shortcut> &> sig;
  
private:

  DJV_CALLBACK(Widget, widget_callback, const _Callback_Data &);

  void widget_update();
  void value_update();

  List<Shortcut> _list;
  
  struct _Widget;
  std::auto_ptr<_Widget> _p;
};

//------------------------------------------------------------------------------
// Comparison

bool operator == (const Shortcut &, const Shortcut &);
bool operator != (const Shortcut &, const Shortcut &);

//------------------------------------------------------------------------------
// Conversion

bool serialize(Str *, int *);
Str serialize(int);

//------------------------------------------------------------------------------
// Labels

const List<Str> & label_key();
const List<Str> & label_mod();
const List<Str> & label_shortcut();

extern const Str
  prefs_title;

}
}

#endif
