/*------------------------------------------------------------------------------
 lib/djv_base/dir_etc.cxx

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#undef DJV_DBG
//#define DJV_DBG

#include <djv_base/dir.h>
#include <FL/filename.H>
#if defined(WIN32)
#include <shlobj.h>
#include <windows.h>
#endif

namespace djv_base {
namespace dir {

#if defined(WIN32)

Str desktop()
{
  // XXX TCHAR conversion?
  
  TCHAR path [MAX_PATH] = "";
  ::SHGetFolderPath(NULL, CSIDL_DESKTOPDIRECTORY, NULL, 0, path);
  return Str(path);
}

#else

Str desktop()
{
  return home() + "/Desktop";
}

#endif

#if ! defined(WIN32)

Str home()
{
  char out [str::cstr_size] = "";
  fl_filename_expand(out, str::cstr_size, "~");
  return out;
}

#endif

#if defined(WIN32)

List<Str> drive_list()
{
  DJV_DBG_OBJ("drive_list");

  List<Str> out;
  
  // XXX TCHAR conversion?

  TCHAR path [MAX_PATH] = "";
  const DWORD size = ::GetLogicalDriveStrings(MAX_PATH - 1, path);
  for (DWORD i = 0, j = 0; i < size; ++i)
    if (! path[i])
    {
      out += Str(path + j, i - j);
      j = i + 1;
    }

  DJV_DBG_PRN("out = " << out);
  return out;
}

#else

Str root()
{
  return Str(file::path_separator, 1);
}

#endif

}
}
