/*------------------------------------------------------------------------------
 lib/djv_image/app_etc.cxx

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

//#define DJV_DBG

#include <djv_image/app.h>

namespace djv_image {
namespace app {

const Str label_info =
"%%"
"\n"
"OpenGL:\n"
"* Pipeline: %%\n"
"* Offscreen Buffer: %%\n"
"* Vendor String: %%\n"
"* Renderer String: %%\n"
"* Version String: %%\n"
"\n"
"Image I/O:\n"
"* Load: %%\n"
"* Save: %%\n";

const Str label_cmdln_help =
"Time:\n"
"\n"
"* -time_units (value)\n"
"  Time units: %%. Value: %%.\n"
"\n"
"* -speed_default (value)\n"
"  Default speed: %%. Value: %%.\n"
"\n"
"OpenGL:\n"
"\n"
"* -gl_pipeline (value)\n"
"  Pipeline: %%. Value: %%.\n"
"\n"
"* -gl_filter (value)\n"
"  Image filter: %%. Value: %%.\n"
"\n"
"* -gl_filter_default (value) (value)\n"
"  Default image filter: %%. Value: %%.\n"
"\n"
"* -gl_filter_custom (value) (value)\n"
"  Custom image filter: %%. Value: %%.\n"
"\n"
"* -gl_offscreen (value)\n"
"  Offscreen rendering buffer: %%. Value: %%.\n"
"\n"
"Image I/O:\n"
"\n"
"* -io_load (plugin) (option) (value)\n"
"  -io_save (plugin) (option) (value)\n"
"  Set an image I/O option (see documentation for available options: "
"http://djv.sourceforge.net/image_io.html).\n"
"\n"
"%%";

App * global() { return static_cast<App *>(djv_base::app::global()); }

}

namespace gl {
Global * global() { return app::global()->gl(); }
}
namespace gl_data {
Global * global() { return app::global()->gl_data(); }
}
namespace gl_offscreen {
Global * global() { return app::global()->gl_offscreen(); }
}
namespace time {
Global * global() { return app::global()->time(); }
}
namespace io {
Global * global() { return app::global()->io(); }
}

}
