/*------------------------------------------------------------------------------
 lib/djv_image/cgl_offscreen.h

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef _DJV_IMAGE_CGL_OFFSCREEN_H
#define _DJV_IMAGE_CGL_OFFSCREEN_H

#include "gl_offscreen.h"
#include <OpenGL/OpenGL.h>

namespace djv_image {
namespace gl_offscreen {

//------------------------------------------------------------------------------
// Pixel Buffer

class _Pbuffer
{
public:

  _Pbuffer();
  ~_Pbuffer();
  
  void init(const Info &, const CGLPixelFormatObj) throw (Error);
  void current() throw (Error);
  
  const Info & info() const { return _info; }
  
private:

  Info _info;
  CGLContextObj _context;
  CGLPBufferObj _pbuffer;
};

class _Cgl_Pbuffer_Factory : public _Pbuffer_Factory
{
public:

  _Cgl_Pbuffer_Factory();
  ~_Cgl_Pbuffer_Factory();
  
  void init() throw (Error);
  void add(_Pbuffer *);
  
  _Pbuffer * get(const Info &) throw (Error);

  CGLPixelFormatObj format() const { return _format; }
  
private:

  List<_Pbuffer *> _list;
  static const int _list_max = 10;
  CGLPixelFormatObj _format;
};

//------------------------------------------------------------------------------
// Labels

const Str
  error_cgl = "CGL",
  error_cgl_pbuffer_create = "PBuffer Create: %%",
  error_cgl_pbuffer_set = "PBuffer Set: %%",
  error_cgl_pbuffer_describe = "PBuffer Describe: %%";

}
}

#endif
