/*------------------------------------------------------------------------------
 lib/djv_ui/base_etc.cxx

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#undef DJV_DBG
//#define DJV_DBG

#include <djv_ui/base.h>
#include <djv_base/math.h>
#include <FL/Fl.H>
#include <FL/fl_draw.H>

namespace djv_ui {
namespace base {

void cursor(const Fl_Cursor & in)
{
  fl_cursor(in);

  // XXX
  
  Fl::flush();
}

Vec2i str_size(const Str & in)
{
  DJV_DBG_OBJ("str_size");
  DJV_DBG_PRN("in = " << in);
  
  const List<Str> lines = str::split(in, '\n', true);
  DJV_DBG_PRN("lines = " << lines.size());

  int width = 0;
  for (uint i = 0; i < lines.size(); ++i)
    width = math::max(str_width(lines[i]), width);

  const Vec2i out(width, lines.size() * fl_height());
  DJV_DBG_PRN("out = " << out);
  return out;
}

int str_width(const Str & in)
{
  return math::ceil(fl_width(in.c_str()));
}

const Str tooltip_reset = "Reset value.";

}
}
