/*------------------------------------------------------------------------------
 lib/djv_ui/gl.cxx

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#undef DJV_DBG
//#define DJV_DBG

#include <djv_ui/gl.h>

namespace djv_ui {
namespace gl {

Widget::Widget() :
  Fl_Gl_Window(0, 0, 0, 0)
{
  Fl_Gl_Window::end();
  Fl_Gl_Window::mode(FL_RGB | FL_DOUBLE);
}

Widget::~Widget()
{}

int Widget::handle(int in)
{
  switch (widget::Base::handle(in))
  {
    case -1: return 0;
    case 1: return 1;
  }
  return Fl_Gl_Window::handle(in);
}

void Widget::show()
{
  Fl_Gl_Window::show();
  widget::Base::show();
}

void Widget::draw()
{
  Fl_Gl_Window::draw();
  widget::Base::draw();
}

void Widget::geom(const Box2i & in)
{
  Fl_Gl_Window::resize(in.x, in.y, in.w, in.h);
  widget::Base::geom(in);
}

const Box2i & Widget::geom() const { return widget::Base::geom(); }

void Widget::resize(int x, int y, int w, int h)
{
  geom(Box2i(x, y, w, h));
}

int Widget::visible() const { return Fl_Gl_Window::visible(); }

}
}

