/*------------------------------------------------------------------------------
 plugin/djv_quicktime_unix/base.h
 
 Image I/O - QuickTime (UNIX version)
 ------------------------------------
 
 Apple QuickTime movie file format.
 
 Requires:
 
 * libquicktime - http://libquicktime.sourceforge.net

 Support:
 
 * Image data: RGBA, 8-bit.
 * File compression.
 
 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_QUICKTIME_UNIX_BASE_H
#define DJV_QUICKTIME_UNIX_BASE_H

#include <djv_image/base.h>
#include <lqt/colormodels.h>
#include <lqt/lqt.h>

namespace djv_quicktime {
using namespace djv_base;
using namespace djv_image;

//------------------------------------------------------------------------------
// Information

static const Str name = "QuickTime";

static const List<Str> extension_list = List<Str>() <<
  ".qt" <<
  ".mov" <<
  ".avi" <<
//  ".mpg" <<
//  ".mpeg" <<
  ".mp4";
//  ".wmv" <<
//  ".divx" <<

//------------------------------------------------------------------------------
// Functions

void quicktime_init();

//------------------------------------------------------------------------------
// Labels

List<Str> label_codec();

extern const Str
  error_video,
  error_codec,
  error_colormodel;

}

#endif

