/*------------------------------------------------------------------------------
 plugin/djv_quicktime_unix/ui.h

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_QUICKTIME_UI_H
#define DJV_QUICKTIME_UI_H

#include <djv_quicktime_unix/io.h>
#include <djv_ui/image_io.h>

namespace djv_quicktime {
namespace ui {
using namespace djv_ui;

//------------------------------------------------------------------------------
// Save Widget

class Save : public djv_ui::image_io::Save
{
public:

  Save();

  Plugin * copy() const;
  const Str & name() const;

  void set(djv_image::io::Plugin *);
  
private:

  DJV_CALLBACK(Save, codec_callback, int);

  void plugin_update();
  void widget_update();
  
  djv_image::io::Plugin * _plugin;
  io::Save_Option _option;
  
  struct _Save;
  std::auto_ptr<_Save> _p;
};

//------------------------------------------------------------------------------
// Labels

extern const Str
  label_codec_group,
  label_codec;

}
}

#endif

