/*------------------------------------------------------------------------------
 plugin/djv_tiff/ui.h

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_TIFF_UI_H
#define DJV_TIFF_UI_H

#include <djv_tiff/io.h>
#include <djv_ui/image_io.h>

namespace djv_tiff {
namespace ui {
using namespace djv_ui;

//------------------------------------------------------------------------------
// Save Widget

class Save : public djv_ui::image_io::Save
{
public:

  Save();
  
  plugin::Plugin * copy() const;
  const Str & name() const;

  void set(djv_image::io::Plugin *);
  
private:

  DJV_CALLBACK(Save, compress_callback, int);
  DJV_CALLBACK(Save, channels_callback, int);

  void plugin_update();
  void widget_update();
  
  djv_image::io::Plugin * _plugin;
  io::Save_Option _option;
  
  struct _Save;
  std::auto_ptr<_Save> _p;
};

//------------------------------------------------------------------------------
// Labels

extern const Str
  label_compress_group,
  label_compress;

}
}

#endif

