/*------------------------------------------------------------------------------
 plugin/djv_vlut/etc.cxx
 
 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

//#define DJV_DBG

#include "base.h"
#include <djv_image/io.h>

namespace djv_vlut {

#if defined(WIN32)

Handle::Handle() :
  _display(0)
{}

Handle::~Handle()
{
  close();
}

void Handle::open() throw (Error)
{
  DJV_DBG_OBJ("Handle::open");

  close();
  
  _display = ::GetDC(0);
  
  if (! _display)
    throw Error(name, djv_image::io::error_open);
}

void Handle::close()
{
  if (_display)
  {
    ::ReleaseDC(0, _display);
    _display = 0;
  }
}
  
HDC Handle::operator () () const { return _display; }

#endif

}

