/*------------------------------------------------------------------------------
 plugin/djv_vlut/io.h

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_VLUT_PLUGIN_H
#define DJV_VLUT_PLUGIN_H

#include "base.h"
#include <djv_image/io.h>

namespace djv_vlut {
namespace io {
using namespace djv_base;
using namespace djv_image;

//------------------------------------------------------------------------------
// Load Plugin

class Load : public djv_image::io::Load
{
public:
  
  plugin::Plugin * copy() const;
  const Str & name() const;
  const List<Str> & extension_list() const;
  
  void open(const File &, Info *, Tag *, djv_image::Time *) throw (Error);
  void open(const File &, List<Info> *, Tag *, djv_image::Time *) throw (Error);
  const Image * get(int frame, int layer, data::PROXY) throw (Error);

private:

  Info _info;
  Image _image;
  Data _tmp;
#if defined(WIN32)
  Handle _handle;
#endif
};

//------------------------------------------------------------------------------
// Save Plugin

class Save : public djv_image::io::Save
{
public:
  
  plugin::Plugin * copy() const;
  const Str & name() const;
  const List<Str> & extension_list() const;
  
  void open(const File &, const Info &, const Tag &, const djv_image::Time &)
    throw (Error);
  void set(const Image &, int frame) throw (Error);

private:

  Info _info;
  Image _image;
  Data _tmp;
#if defined(WIN32)
  Handle _handle;
#endif
};

}
}

#endif

