#ifndef APP_H
#define APP_H

#include "op.h"
#include "widget.h"
#include <djv_ui/app.h>
#include <djv_ui/button.h>
#include <djv_ui/slider.h>
#include <djv_ui/window.h>
#include <djv_image/io.h>

namespace glsl {
using namespace djv_base;

class App : public djv_ui::app::App
{
public:

  App(int argc, char ** argv);
  ~App();
  
private:

  void play(bool);

  DJV_CALLBACK(App, play_callback, bool);
  DJV_CALLBACK(App, frame_callback, int);
  DJV_CALLBACK(App, op_callback, int);
  DJV_CALLBACK(App, update_callback, bool);
  DJV_CALLBACK(App, close_callback, bool);
  DJV_FL_CALLBACK(App, idle_callback);
  
  void play_update();
  void frame_update();
  void update();

  std::auto_ptr<djv_image::io::Load> _load;
  djv_image::Info _info;
  djv_image::Tag _tag;
  djv_image::Time _time;
  bool _play;
  int _frame;
  List<Op *> _op_list;
  int _op;
  
  djv_ui::window::Widget * _window_image;
  Widget * _view;
  djv_ui::button::Tool * _play_widget;
  djv_ui::slider::Int * _slider;
  djv_ui::window::Widget * _window_widget;
};

}

#endif
