#include "op_blur.h"
#include <djv_ui/choice.h>
#include <djv_ui/group.h>
#include <djv_ui/label.h>
#include <djv_ui/layout_row.h>
#include <djv_ui/num_int.h>

namespace glsl {
namespace op_blur {

Op::Op()
{
  using namespace djv_ui;
  
  // Widgets.
  
  group::Box * radius_group =
    new group::Box("Radius");
  num::Int_Slider * radius =
    new num::Int_Slider(0, 127);
  
  group::Box * filter_group =
    new group::Box("Filter");
  choice::Widget * filter =
    new choice::Widget(label_filter());
  
  // Layout.
  
  Layout_V * layout = new Layout_V(this);
  layout->add(radius_group);
  Layout_V * layout_v = new Layout_V(radius_group);
  layout_v->add(radius);
  layout->add(filter_group);
  layout_v = new Layout_V(filter_group);
  layout_v->add(filter);
  layout->add_stretch();
  
  // Initialize.
  
  radius->set(_value.radius);
  filter->set(_value.filter);
  
  // Callbacks.

  radius->sig.set(this, radius_callback);
  filter->sig.set(this, filter_callback);
}

void Op::radius_callback(int in)
  { sig.emit((_value.radius = in)); }
void Op::filter_callback(int in)
  { sig.emit((_value.filter = FILTER(in))); }

}
}
